diff --git a/misc/Makefile b/misc/Makefile
index f34ab09fe3..fa40bf0e11 100644
--- a/misc/Makefile
+++ b/misc/Makefile
@@ -148,6 +148,12 @@ CFLAGS-brk.op = $(no-stack-protector)
 
 include ../Rules
 
+ifeq (yes,$(build-shared))
+librt = $(common-objpfx)rt/librt.so
+else
+librt = $(common-objpfx)rt/librt.a
+endif
+
 $(objpfx)libg.a: $(dep-dummy-lib); $(make-dummy-lib)
 
 $(objpfx)tst-tsearch: $(libm)
@@ -162,3 +168,6 @@ tst-allocate_once-ENV = MALLOC_TRACE=$(objpfx)tst-allocate_once.mtrace
 $(objpfx)tst-allocate_once-mem.out: $(objpfx)tst-allocate_once.out
 	$(common-objpfx)malloc/mtrace $(objpfx)tst-allocate_once.mtrace > $@; \
 	$(evaluate-test)
+
+$(objpfx)tst-pselect: $(librt)
+$(objpfx)tst-pselect-time64: $(librt)
diff --git a/misc/tst-pselect.c b/misc/tst-pselect.c
index c89176b058..f8c404c275 100644
--- a/misc/tst-pselect.c
+++ b/misc/tst-pselect.c
@@ -16,14 +16,14 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <errno.h>
-#include <signal.h>
-#include <stdio.h>
-#include <unistd.h>
-#include <sys/select.h>
-#include <sys/wait.h>
+#include <intprops.h>
+#include <support/check.h>
+#include <support/support.h>
+#include <support/xsignal.h>
+#include <support/xunistd.h>
+#include <support/xtime.h>
 #include <stdlib.h>
 
-
 static volatile int handler_called;
 
 static void
@@ -33,59 +33,43 @@ handler (int sig)
 }
 
 
-static int
-do_test (void)
+static void
+test_pselect_basic (void)
 {
   struct sigaction sa;
   sa.sa_handler = handler;
   sa.sa_flags = 0;
   sigemptyset (&sa.sa_mask);
 
-  if (sigaction (SIGUSR1, &sa, NULL) != 0)
-    {
-      puts ("sigaction failed");
-      return 1;
-    }
+  xsigaction (SIGUSR1, &sa, NULL);
 
   sa.sa_handler = SIG_IGN;
-  if (sigaction (SIGCHLD, &sa, NULL) != 0)
-    {
-      puts ("2nd sigaction failed");
-      return 1;
-    }
+  xsigaction (SIGCHLD, &sa, NULL);
 
   sigset_t ss_usr1;
   sigemptyset (&ss_usr1);
   sigaddset (&ss_usr1, SIGUSR1);
-  if (sigprocmask (SIG_BLOCK, &ss_usr1, NULL) != 0)
-    {
-      puts ("sigprocmask failed");
-      return 1;
-    }
+  TEST_COMPARE (sigprocmask (SIG_BLOCK, &ss_usr1, NULL), 0);
 
   int fds[2][2];
-
-  if (pipe (fds[0]) != 0 || pipe (fds[1]) != 0)
-    {
-      puts ("pipe failed");
-      return 1;
-    }
+  xpipe (fds[0]);
+  xpipe (fds[1]);
 
   fd_set rfds;
   FD_ZERO (&rfds);
 
   sigset_t ss;
-  sigprocmask (SIG_SETMASK, NULL, &ss);
+  TEST_COMPARE (sigprocmask (SIG_SETMASK, NULL, &ss), 0);
   sigdelset (&ss, SIGUSR1);
 
   struct timespec to = { .tv_sec = 0, .tv_nsec = 500000000 };
 
   pid_t parent = getpid ();
-  pid_t p = fork ();
+  pid_t p = xfork ();
   if (p == 0)
     {
-      close (fds[0][1]);
-      close (fds[1][0]);
+      xclose (fds[0][1]);
+      xclose (fds[1][0]);
 
       FD_SET (fds[0][0], &rfds);
 
@@ -93,55 +77,63 @@ do_test (void)
       do
 	{
 	  if (getppid () != parent)
-	    exit (2);
+	    FAIL_EXIT1 ("getppid()=%d != parent=%d", getppid(), parent);
 
 	  errno = 0;
 	  e = pselect (fds[0][0] + 1, &rfds, NULL, NULL, &to, &ss);
 	}
       while (e == 0);
 
-      if (e != -1)
-	{
-	  puts ("child: pselect did not fail");
-	  return 0;
-	}
-      if (errno != EINTR)
-	{
-	  puts ("child: pselect did not set errno to EINTR");
-	  return 0;
-	}
+      TEST_COMPARE (e, -1);
+      TEST_COMPARE (errno, EINTR);
 
       TEMP_FAILURE_RETRY (write (fds[1][1], "foo", 3));
 
       exit (0);
     }
 
-  close (fds[0][0]);
-  close (fds[1][1]);
+  xclose (fds[0][0]);
+  xclose (fds[1][1]);
 
   FD_SET (fds[1][0], &rfds);
 
-  kill (p, SIGUSR1);
+  TEST_COMPARE (kill (p, SIGUSR1), 0);
 
   int e = pselect (fds[1][0] + 1, &rfds, NULL, NULL, NULL, &ss);
-  if (e == -1)
-    {
-      puts ("parent: pselect failed");
-      return 1;
-    }
-  if (e != 1)
-    {
-      puts ("parent: pselect did not report readable fd");
-      return 1;
-    }
-  if (!FD_ISSET (fds[1][0], &rfds))
-    {
-      puts ("parent: pselect reports wrong fd");
-      return 1;
-    }
+  TEST_COMPARE (e, 1);
+  TEST_VERIFY (FD_ISSET (fds[1][0], &rfds));
+}
+
+static void
+test_pselect_large_timeout (void)
+{
+  support_create_timer (0, 100000000, false, NULL);
+
+  int fds[2];
+  xpipe (fds);
+
+  fd_set rfds;
+  FD_ZERO (&rfds);
+  FD_SET (fds[0], &rfds);
+
+  sigset_t ss;
+  TEST_COMPARE (sigprocmask (SIG_SETMASK, NULL, &ss), 0);
+  sigdelset (&ss, SIGALRM);
+
+  struct timespec ts = { TYPE_MAXIMUM (time_t), 0 };
+
+  TEST_COMPARE (pselect (fds[0] + 1, &rfds, NULL, NULL, &ts, &ss), -1);
+  TEST_VERIFY (errno == EINTR || errno == EOVERFLOW);
+}
+
+static int
+do_test (void)
+{
+  test_pselect_basic ();
+
+  test_pselect_large_timeout ();
 
   return 0;
 }
 
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
+#include <support/test-driver.c>
diff --git a/sysdeps/unix/sysv/linux/microblaze/pselect32.c b/sysdeps/unix/sysv/linux/microblaze/pselect32.c
index a4f436462b..70b7b52a48 100644
--- a/sysdeps/unix/sysv/linux/microblaze/pselect32.c
+++ b/sysdeps/unix/sysv/linux/microblaze/pselect32.c
@@ -35,8 +35,7 @@ __pselect32 (int nfds, fd_set *readfds, fd_set *writefds,
   struct timeval tv32, *ptv32 = NULL;
   if (timeout != NULL)
     {
-      if (! in_time_t_range (timeout->tv_sec)
-	  || ! valid_nanoseconds (timeout->tv_nsec))
+      if (! valid_nanoseconds (timeout->tv_nsec))
 	{
 	  __set_errno (EINVAL);
 	  return -1;
diff --git a/sysdeps/unix/sysv/linux/pselect.c b/sysdeps/unix/sysv/linux/pselect.c
index 5e8a0cc2dc..79e8584ea7 100644
--- a/sysdeps/unix/sysv/linux/pselect.c
+++ b/sysdeps/unix/sysv/linux/pselect.c
@@ -18,7 +18,23 @@
 
 #include <sys/select.h>
 #include <sysdep-cancel.h>
-#include <time64-support.h>
+
+static int
+pselect64_syscall (int nfds, fd_set *readfds, fd_set *writefds,
+		   fd_set *exceptfds, const struct __timespec64 *timeout,
+		   const sigset_t *sigmask)
+{
+#ifndef __NR_pselect6_time64
+# define __NR_pselect6_time64 __NR_pselect6
+#endif
+  /* NB: This is required by ARGIFY used in x32 internal_syscallN.  */
+  __syscall_ulong_t data[2] =
+    {
+      (uintptr_t) sigmask, __NSIG_BYTES
+    };
+  return SYSCALL_CANCEL (pselect6_time64, nfds, readfds, writefds, exceptfds,
+			 timeout, data);
+}
 
 int
 __pselect64 (int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds,
@@ -37,30 +53,25 @@ __pselect64 (int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds,
      we can only pass in 6 directly.  If there is an architecture with
      support for more parameters a new version of this file needs to
      be created.  */
-
-#ifndef __NR_pselect6_time64
-# define __NR_pselect6_time64 __NR_pselect6
-#endif
+#ifdef __ASSUME_TIME64_SYSCALLS
+  return pselect64_syscall (nfds, readfds, writefds, exceptfds, timeout,
+			    sigmask);
+#else
+  bool is32bit = timeout != NULL
+		 ? in_time_t_range (timeout->tv_sec) : true;
   int r;
-  if (supports_time64 ())
+  if (!is32bit)
     {
-      /* NB: This is required by ARGIFY used in x32 internal_syscallN.  */
-      __syscall_ulong_t data[2] =
-	{
-	  (uintptr_t) sigmask, __NSIG_BYTES
-	};
-      r = SYSCALL_CANCEL (pselect6_time64, nfds, readfds, writefds, exceptfds,
-			  timeout, data);
+      r = pselect64_syscall (nfds, readfds, writefds, exceptfds, timeout,
+			     sigmask);
       if (r == 0 || errno != ENOSYS)
 	return r;
-
-      mark_time64_unsupported ();
+      __set_errno (EOVERFLOW);
+      return -1;
     }
 
-#ifndef __ASSUME_TIME64_SYSCALLS
-  r = __pselect32 (nfds, readfds, writefds, exceptfds, timeout, sigmask);
+  return __pselect32 (nfds, readfds, writefds, exceptfds, timeout, sigmask);
 #endif
-  return r;
 }
 
 #if __TIMESIZE != 64
diff --git a/sysdeps/unix/sysv/linux/pselect32.c b/sysdeps/unix/sysv/linux/pselect32.c
index eb59b51cdf..48724d8727 100644
--- a/sysdeps/unix/sysv/linux/pselect32.c
+++ b/sysdeps/unix/sysv/linux/pselect32.c
@@ -29,12 +29,6 @@ __pselect32 (int nfds, fd_set *readfds, fd_set *writefds,
   struct timespec ts32, *pts32 = NULL;
   if (timeout != NULL)
     {
-      if (! in_time_t_range (timeout->tv_sec))
-	{
-	  __set_errno (EINVAL);
-	  return -1;
-	}
-
       ts32 = valid_timespec64_to_timespec (*timeout);
       pts32 = &ts32;
     }