diff --git a/misc/Makefile b/misc/Makefile
index 9f42321206..1a21347f5e 100644
--- a/misc/Makefile
+++ b/misc/Makefile
@@ -23,79 +23,240 @@ subdir	:= misc
 
 include ../Makeconfig
 
-headers	:= sys/uio.h bits/uio-ext.h bits/uio_lim.h \
-	   sys/ioctl.h bits/ioctls.h bits/ioctl-types.h \
-	   sys/ptrace.h sys/file.h sys/dir.h sys/cdefs.h \
-	   ar.h a.out.h libgen.h stab.h bits/stab.def sgtty.h \
-	   ttyent.h paths.h sys/reboot.h \
-	   sys/mman.h sys/param.h bits/param.h \
-	   fstab.h mntent.h search.h err.h error.h \
-	   sys/queue.h sysexits.h syscall.h sys/syscall.h sys/swap.h \
-	   sys/select.h sys/sysinfo.h \
-	   regexp.h bits/select.h bits/mman.h sys/xattr.h \
-	   syslog.h sys/syslog.h \
-	   bits/syslog.h bits/syslog-ldbl.h bits/syslog-path.h bits/error.h \
-	   bits/select2.h bits/hwcap.h sys/auxv.h \
-	   sys/sysmacros.h bits/sysmacros.h bits/types/struct_iovec.h \
-	   bits/err-ldbl.h bits/error-ldbl.h \
-	   sys/single_threaded.h
-
-routines := brk sbrk sstk ioctl \
-	    readv writev preadv preadv64 pwritev pwritev64 \
-	    preadv2 preadv64v2 pwritev2 pwritev64v2 \
-	    setreuid setregid \
-	    seteuid setegid \
-	    getpagesize \
-	    getdtsz \
-	    gethostname sethostname getdomain setdomain \
-	    select pselect \
-	    acct chroot fsync sync fdatasync syncfs reboot \
-	    gethostid sethostid \
-	    revoke vhangup \
-	    swapon swapoff mktemp mkstemp mkstemp64 mkdtemp \
-	    mkostemp mkostemp64 mkstemps mkstemps64 mkostemps mkostemps64 \
-	    ualarm usleep \
-	    gtty stty \
-	    ptrace \
-	    fstab mntent mntent_r \
-	    utimes lutimes futimes futimesat \
-	    truncate ftruncate truncate64 ftruncate64 \
-	    chflags fchflags \
-	    insremque getttyent getusershell getpass ttyslot \
-	    syslog syscall daemon \
-	    mmap mmap64 munmap mprotect msync madvise mincore remap_file_pages\
-	    mlock munlock mlockall munlockall \
-	    efgcvt efgcvt_r qefgcvt qefgcvt_r \
-	    hsearch hsearch_r tsearch lsearch \
-	    err error ustat \
-	    getsysstats dirname regexp \
-	    getloadavg getclktck \
-	    fgetxattr flistxattr fremovexattr fsetxattr getxattr \
-	    listxattr lgetxattr llistxattr lremovexattr lsetxattr \
-	    removexattr setxattr getauxval ifunc-impl-list makedev \
-	    allocate_once fd_to_filename single_threaded unwind-link \
-	    atomic_wide_counter
-
-generated += tst-error1.mtrace tst-error1-mem.out \
-  tst-allocate_once.mtrace tst-allocate_once-mem.out
+headers	:= \
+  sys/uio.h \
+  bits/uio-ext.h \
+  bits/uio_lim.h \
+  sys/ioctl.h \
+  bits/ioctls.h \
+  bits/ioctl-types.h \
+  sys/ptrace.h \
+  sys/file.h \
+  sys/dir.h \
+  sys/cdefs.h \
+  ar.h \
+  a.out.h \
+  libgen.h \
+  stab.h \
+  bits/stab.def \
+  sgtty.h \
+  ttyent.h \
+  paths.h \
+  sys/reboot.h \
+  sys/mman.h \
+  sys/param.h \
+  bits/param.h \
+  fstab.h \
+  mntent.h \
+  search.h \
+  err.h \
+  error.h \
+  sys/queue.h \
+  sysexits.h \
+  syscall.h \
+  sys/syscall.h \
+  sys/swap.h \
+  sys/select.h \
+  sys/sysinfo.h \
+  regexp.h \
+  bits/select.h \
+  bits/mman.h \
+  sys/xattr.h \
+  syslog.h \
+  sys/syslog.h \
+  bits/syslog.h \
+  bits/syslog-ldbl.h \
+  bits/syslog-path.h \
+  bits/error.h \
+  bits/select2.h \
+  bits/hwcap.h \
+  sys/auxv.h \
+  sys/sysmacros.h \
+  bits/sysmacros.h \
+  bits/types/struct_iovec.h \
+  bits/err-ldbl.h \
+  bits/error-ldbl.h \
+  sys/single_threaded.h \
+  # headers
+
+routines := \
+  acct \
+  allocate_once \
+  atomic_wide_counter \
+  brk \
+  chflags \
+  chroot \
+  daemon \
+  dirname \
+  efgcvt \
+  efgcvt_r \
+  err \
+  error \
+  fchflags \
+  fd_to_filename \
+  fdatasync \
+  fgetxattr \
+  flistxattr \
+  fremovexattr \
+  fsetxattr \
+  fstab \
+  fsync \
+  ftruncate \
+  ftruncate64 \
+  futimes \
+  futimesat \
+  getauxval \
+  getclktck \
+  getdomain \
+  getdtsz \
+  gethostid \
+  gethostname \
+  getloadavg \
+  getpagesize \
+  getpass \
+  getsysstats \
+  getttyent \
+  getusershell \
+  getxattr \
+  gtty \
+  hsearch \
+  hsearch_r \
+  ifunc-impl-list \
+  insremque \
+  ioctl \
+  lgetxattr \
+  listxattr \
+  llistxattr \
+  lremovexattr \
+  lsearch \
+  lsetxattr \
+  lutimes \
+  madvise \
+  makedev \
+  mincore \
+  mkdtemp \
+  mkostemp \
+  mkostemp64 \
+  mkostemps \
+  mkostemps64 \
+  mkstemp \
+  mkstemp64 \
+  mkstemps \
+  mkstemps64 \
+  mktemp \
+  mlock \
+  mlockall \
+  mmap \
+  mmap64 \
+  mntent \
+  mntent_r \
+  mprotect \
+  msync \
+  munlock \
+  munlockall \
+  munmap \
+  preadv \
+  preadv64 \
+  preadv2 \
+  preadv64v2 \
+  pselect \
+  ptrace \
+  pwritev \
+  pwritev64 \
+  pwritev2 \
+  pwritev64v2 \
+  qefgcvt \
+  qefgcvt_r \
+  readv \
+  reboot \
+  regexp \
+  remap_file_pages \
+  removexattr \
+  revoke \
+  sbrk \
+  select \
+  setdomain \
+  setegid \
+  seteuid \
+  sethostid \
+  sethostname \
+  setregid \
+  setreuid \
+  setxattr \
+  single_threaded \
+  sstk \
+  stty \
+  swapoff \
+  swapon \
+  sync \
+  syncfs \
+  syscall \
+  syslog \
+  truncate \
+  truncate64 \
+  tsearch \
+  ttyslot \
+  ualarm \
+  unwind-link \
+  usleep \
+  ustat \
+  utimes \
+  vhangup \
+  writev \
+  # routines
+
+generated += \
+  tst-allocate_once-mem.out \
+  tst-allocate_once.mtrace \
+  tst-error1-mem.out \
+  tst-error1.mtrace \
+  # generated
 
 aux := init-misc
 install-lib := libg.a
-gpl2lgpl := error.c error.h
 
-tests := tst-dirname tst-tsearch tst-fdset tst-mntent tst-hsearch \
-	 tst-error1 tst-pselect tst-insremque tst-mntent2 bug-hsearch1 \
-	 tst-mntent-blank-corrupt tst-mntent-blank-passno bug18240 \
-	 tst-preadvwritev tst-preadvwritev64 tst-makedev tst-empty \
-	 tst-preadvwritev2 tst-preadvwritev64v2 tst-warn-wide \
-	 tst-ldbl-warn tst-ldbl-error tst-dbl-efgcvt tst-ldbl-efgcvt \
-	 tst-mntent-autofs tst-syscalls tst-mntent-escape tst-select \
-	 tst-ioctl tst-ldbl-errorfptr
+gpl2lgpl := \
+  error.c \
+  error.h \
+  # gpl2lgpl
+
+tests := \
+  bug-hsearch1 \
+  bug18240 \
+  tst-dbl-efgcvt \
+  tst-dirname \
+  tst-empty \
+  tst-error1 \
+  tst-fdset \
+  tst-hsearch \
+  tst-insremque \
+  tst-ioctl \
+  tst-ldbl-efgcvt \
+  tst-ldbl-error \
+  tst-ldbl-errorfptr \
+  tst-ldbl-warn \
+  tst-makedev \
+  tst-mntent \
+  tst-mntent-autofs \
+  tst-mntent-blank-corrupt \
+  tst-mntent-blank-passno \
+  tst-mntent-escape \
+  tst-mntent2 \
+  tst-preadvwritev \
+  tst-preadvwritev64 \
+  tst-preadvwritev2 \
+  tst-preadvwritev64v2 \
+  tst-pselect \
+  tst-select \
+  tst-syscalls \
+  tst-tsearch \
+  tst-warn-wide \
+  # tests
 
 tests-time64 := \
-  tst-select-time64 \
-  tst-pselect-time64 \
   tst-ioctl-time64 \
+  tst-pselect-time64 \
+  tst-select-time64 \
   # tests-time64
 
 # Tests which need libdl.
@@ -103,7 +264,11 @@ ifeq (yes,$(build-shared))
 tests += tst-gethostid
 endif
 
-tests-internal := tst-atomic tst-atomic-long tst-allocate_once
+tests-internal := \
+  tst-allocate_once \
+  tst-atomic \
+  tst-atomic-long \
+  # tests-internal
 tests-static := tst-empty
 
 # Test for the internal, non-exported __fd_to_filename function.